<?php
// Converge options
// TODO: delete this entire file once all installs are on a version greater than 1.0.72
// This file is only here to support wordpress websites that cache their HTML so they will hit this old
// script tag instead of the new way (wp-json api etc)
$seeka_converge_options = array(
    "converge_key_0" => isset($_GET["s_key"]) && $_GET["s_key"] ? $_GET["s_key"] : '',
    "converge_org_0" => isset($_GET["s_org"]) && $_GET["s_org"] ? $_GET["s_org"] : '',
    "converge_endpoint_1" => isset($_GET["s_e"]) && $_GET["s_e"] ? $_GET["s_e"] : '',
    'converge_debug_mode_enabled_2' => isset($_GET["s_dme"]) && $_GET["s_dme"] == "1",
    'converge_wait_for_interaction' => isset($_GET["s_wfi"]) && $_GET["s_wfi"] == "1",
    'converge_browser_sdk_version_4' => isset($_GET["s_bsv"]) && $_GET["s_bsv"] ? $_GET["s_bsv"] : '',
    'converge_config_save_increment' => isset($_GET["s_csi"]) && $_GET["s_csi"] ? $_GET["s_csi"] : '0',
    'sdk_local' => isset($_GET["s_sl"]) && $_GET["s_sl"] == "1",
);
$converge_key_0 = $seeka_converge_options['converge_key_0'];
$converge_org_0 = $seeka_converge_options['converge_org_0'];
$converge_endpoint_1 = $seeka_converge_options['converge_endpoint_1'];
$converge_debug_mode_enabled_2 = $seeka_converge_options['converge_debug_mode_enabled_2'];
$converge_wait_for_interaction = $seeka_converge_options['converge_wait_for_interaction'];
$converge_config_save_increment = $seeka_converge_options['converge_config_save_increment'];
$converge_browser_sdk_version_4 = $seeka_converge_options['converge_browser_sdk_version_4'];
$sdk_local = $seeka_converge_options['sdk_local'];

// SDK options
$clientVersion = isset($_GET["s_cv"]) && $_GET["s_cv"] ? $_GET["s_cv"] : '0.0.0';
$clientType = isset($_GET["s_ct"]) && $_GET["s_ct"] ? $_GET["s_ct"] : 'wordpress';

// Get script
$configValid = true;
if (!$seeka_converge_options || !$converge_key_0 || !$converge_org_0) {
    $configValid = false;
    echo 'missing configuration';
    die();
}

$jsContent = "";

$convergeKeyArray = explode(',', $converge_key_0);
$convergeOrgArray = explode(',', $converge_org_0);
$isMultiInstance = count($convergeKeyArray) > 1 && count($convergeOrgArray) > 1;

// Set script URL
if (!$converge_endpoint_1 || $converge_endpoint_1 == '' || trim($converge_endpoint_1) == '') {
    $converge_endpoint_1 = 'https://sdk.seeka.services';
}

// https localhost
$isLocalHost = strpos($converge_endpoint_1, 'https://localhost');
$isLocalHost = !($isLocalHost === -1 || $isLocalHost === false);

// http localhost
if (!$isLocalHost) {
    $isLocalHost = strpos($converge_endpoint_1, 'http://localhost');
    $isLocalHost = !($isLocalHost === -1 || $isLocalHost === false);
}

$isSidekickActive = isset($_GET['_s_sidekick']) && $_GET['_s_sidekick'] === '1';
$disableCache = $isSidekickActive || $sdk_local || (isset($_GET["_cache"]) && $_GET["_cache"] == "0") || (isset($_GET["cache"]) && $_GET["cache"] == "0");

$jsUrl = "$converge_endpoint_1/static/converge/tag.js?client.clientType=" . urlencode($clientType) . "&client.version=" . urlencode($clientVersion);
if ($converge_debug_mode_enabled_2) {
    $jsUrl = $jsUrl . '&diag=true';
}

// Set SDK version override
if ($converge_browser_sdk_version_4) {
    $jsUrl = $jsUrl . '&vo=' . urlencode($converge_browser_sdk_version_4);
}

// Append converge keys and org
for ($i = 0; $i < count($convergeKeyArray); $i++) {
    $convergeKey = $convergeKeyArray[$i];
    $convergeOrg = $convergeOrgArray[$i];
    $jsUrl = $jsUrl . "&k[$i]=" . urlencode($convergeKey) . "&o[$i]=" . urlencode($convergeOrg);
}

// cache bust the url to get fresh copy from CDN
if ($disableCache) {
    $jsUrl = $jsUrl . '&cache=' . gmdate('U');
}

try {
    $ch = curl_init();
    $headers = array(
        'Referrer' => "https://$_SERVER[SERVER_NAME]$_SERVER[REQUEST_URI]"
    );
    curl_setopt($ch, CURLOPT_URL, $jsUrl);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_FAILONERROR, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    if ($isLocalHost) {
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    }
    curl_setopt($ch, CURLOPT_TIMEOUT, $isLocalHost ? 240 : 15); // Timeout in seconds

    $response = curl_exec($ch);
    $http_status = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    $curl_errno = curl_errno($ch);

    if ($response && !$curl_errno) {
        $jsContent = $response;
        $md5ETag = md5($jsContent);

        // set cache headers
        if (!$isLocalHost && !$isSidekickActive && !$disableCache) {
            header("Cache-Control: private, max-age=1800"); // 15 min (60 sec * 15)		
            header('Last-Modified:` ' . gmdate('D, d M Y H:i:s') . ' GMT');
        } else {
            header('Expires: Thu, 01-Jan-70 00:00:01 GMT');
            header('Cache-Control: no-store, no-cache, must-revalidate');
        }

        header('Content-Type: application/javascript');
        header("Etag: $md5ETag");
    } else {
        header('Content-Type: application/javascript');
        echo 'console.error("Seeka - Failed to load base script - responseCode ' . $http_status . ', url ' . $jsUrl . '");';
    }
} catch (Exception $ex) {
    header('Content-Type: text/plain');
    header('Expires: Thu, 01-Jan-70 00:00:01 GMT');
    header('Cache-Control: no-store, no-cache, must-revalidate');
    echo $ex->getMessage() . "\n";
    echo $jsUrl . "\n";
}

$jsContent = "window.Seeka = window.Seeka || {};\nwindow.Seeka.client = window.Seeka.client || {};\nwindow.Seeka.client.origin = { h: '$_SERVER[SERVER_NAME]' };\n" . $jsContent;

echo $jsContent;
if ($jsContent && $converge_debug_mode_enabled_2) {
    ?>
    window.addEventListener("converge.sdk.init.start", function (ev) {
    Converge.debug.toggleDevMode(true);
    });
    <?php
}
?>